{% extends 'base.html' %}
{% load static %}
{% block meta %}

<style>
    p {
        margin-top: 30px;
        font-size: 24px;
    }
    a {
        color: white;
        text-decoration: none;
        font-weight: bold;
        transition: 0.3s;
    }
    a:hover {
        text-decoration: underline;
        font-weight: bold;
        color: white;
    }
    body {
        margin: 0;
    }
    table {
        position: relative;
        bottom: 0px;
        table-layout: fixed;
        border-collapse: collapse;
        width: 100%;
        font-size: 20px;   
        overflow: hidden;
    }
    thead {
        font-size: 24px;
        color: white;
        background-color: #811112;
        height: 48px;
    }
    th {
        text-align: center;
    }
    .header{
        width:100%;
        position:relative;
        top:50px;
        left:0px;
    }
    .header img {
        filter: brightness(50%);
        object-fit: cover;
        object-position: center;
        width: 100%;
        height: 600px;
    }
    .centered {
        color: white;
        position: absolute;
        top: 60%;
        left: 50%;
        transform: translate(-50%, -50%);
        text-align: center;
    }
    .centered atas {
        font-size: 48px;
        font-weight: bold;
    }
    .centered bawah {
        font-size: 96px;
        font-weight: bold;
    }
    .food-image {
        width: 100%;
        height: auto;
    }
    .food-name-container {
        background-color: #811112;
        padding: 15px;
        height: 70px;
        display: flex;
        justify-content: center;
        align-items: center;
    }
    .random:hover {
        color: #811112;
    }
    .search-box {
        margin-top: 100px;
    }
    .search-box button {
        float: left;
        width: 20%;
        height: 60px;
        padding: 12px 20px;
        background: #811112;
        color: white;
        font-size: 24px;
        border: none;
        cursor: pointer;
    }
    .search {
        float: left;
        width: 80%;
        font-family: 'Sora';
        background: #f1f1f1;
        border: none;
        font-size: 24px;
        padding: 12px 20px;
    }
    .search:focus {
        outline-color: #811112;
    }
    .box {
        padding-top: 50px;
    }
    .food-container {
        margin: 1.67%;
        float: left;
        width: 29%;
    }
    #result {
        color: white;
        overflow: hidden;
        margin: 100px;
        text-align: center;
    }
</style>

    <title>Recipe</title>
    {% endblock meta %}
    {% block content %}
    <body>
        <div class="header">
            <img src={{ bg_image }}>
            <div class="centered">
                {% if not limit %}
                <atas>
                    My favorite thing to do at home is
                </atas>
            </br>
                <bawah>
                    COOK
                </bawah>
                <div class="search-box">
                    <input type="text" placeholder="find some food recipes" class="search" id="search-field" onkeydown="searchListener(this)">
                    <button type="submit" onclick="search(this.previousElementSibling.value)"><i class="fa fa-search"></i></button>
                </div>
                <div class="box">
                    <p>or you can <a class="random" href="random/">click me</a> for a random recipe</p>
                </div>
                {% else %}
                <div class="box">
                    <p>You can <a class="random" href="/">click me</a> to back to home page</p>
                </div>
                {% endif %}
                
            </div>
        </div>
        <div id="result" ></div>
        <table>
            <thead>
                <tr>
                    <table>
                <thead>
                    <tr>
                        <th id="more">
                        </th>
                    </tr>
                </thead>
            </table>
                </tr>
            </thead>
        </table>
        <script>
            function searchListener(keyword) {
                if(event.keyCode == 13) {
                    search(keyword.value);
                }
            }

            function changeState(current, keyword, offset) {
                if (current.status == 402) {
                    document.getElementById("result").innerHTML = "Sorry! the recipe API requests has reached the daily limit. Please try again tomorrow.";
                }
                if (current.readyState == 4 && current.status == 200) {
                    if (offset == 0) 
                        document.getElementById('result').innerHTML = "";
                    var data = JSON.parse(current.responseText);
                    var foodList = data.results;

                    if (foodList.length == 0) {
                        document.getElementById("result").innerHTML = "No Result.";
                    } 

                    
                    
                    var moreRow = document.getElementById('more');
                    moreRow.innerHTML = "";
                    if (data.totalResults - offset > 10) {
                        var more = document.createElement('a');
                        more.onclick = function() { search(keyword,offset); };
                        more.innerHTML = "More";
                        var offset = offset+10;
                        console.log(offset);
                        moreRow.appendChild(more);
                    }

                    foodList.forEach(food => {
                        
                        var foodContainer = document.createElement('div');
                        foodContainer.className = "food-container";
                        var bigImage = document.createElement('img');
                        var foodImage = document.createElement('img');
                        foodImage.src = "../static/img/loading.gif";
                        bigImage.onload = function () {
                            foodImage.src = bigImage.src;
                        }
                        bigImage.src = food.image;
                        foodImage.className = "food-image";
                        var foodNameContainer = document.createElement('div');
                        foodNameContainer.className = "food-name-container";
                        var foodName = document.createElement('a');
                        foodName.href = `${food.id}/`;
                        foodName.className = "food-name";
                        foodName.innerHTML = food.title;

                        foodContainer.appendChild(foodImage);
                        foodNameContainer.appendChild(foodName);
                        foodContainer.appendChild(foodNameContainer);
                        document.getElementById('result').appendChild(foodContainer);
                    });
                }
            }

            function search(keyword, offset=0) {
                if (keyword === "") {
                    document.getElementById("result").innerHTML = "You should type any food name";
                } else {
                    var xhr = new XMLHttpRequest();
                    var recipeApi = "{{ RECIPE_API }}";
                    var url = `https://api.spoonacular.com/recipes/complexSearch?query=${keyword}&offset=${offset}&apiKey=093c3f2d670c4f29937ce2bf0b69b565`;

                    if (offset == 0)
                        xhr.onloadstart = function () {
                            document.getElementById("result").innerHTML = "Loading...";
                        };

                    xhr.onreadystatechange = function() {
                        changeState(this, keyword, offset);
                    };
                    
                    xhr.open("GET", url, true);
                    xhr.send();
                }     
            }
        </script>
    </body>
    {% endblock content %}